/* Copyright Notice ======================================================*
* This file contains proprietary information of Netscape Communications.
* Copying or reproduction without prior written approval is prohibited.
* Copyright (c) 1997 ====================================================*/

package util;

import java.text.Collator;

public class SortUtil {

	/**
	 * Sorts the array of strings using bubble sort.
	 * @param str The array of string being sorted. The str parameter contains
	 * the sorted result.
	 * @param isAscii If false, true Unicode collation will be used.
	 */
    public static void bubbleSort(String[] str, boolean isAscii) {
		if ( isAscii ) {
			bubbleSortAscii( str );
		} else {
			bubbleSortCollated( str );
		}
	}

	/**
	 * Sorts the array of strings using bubble sort.
	 * @param str The array of string being sorted. The str parameter contains
	 * the sorted result. Comparison will be done using true Unicode collation.
	 */
    public static void bubbleSort(String[] str) {
		bubbleSortCollated( str );
	}

	/**
	 * Sorts the array of strings using bubble sort.
	 * @param str The array of string being sorted. The str parameter contains
	 * the sorted result.
	 */
    private static void bubbleSortCollated(String[] str) {
		Collator collator = Collator.getInstance(); 
		for (int i = 0; i < str.length-1; i++) {
			for (int j = i+1; j < str.length; j++) {
                if( collator.compare(str[i], str[j]) > 0 ) {
					String t = str[i];
					str[i] = str[j];
					str[j] = t;
				}
			}
		}
	}

	/**
	 * Sorts the array of strings using bubble sort.
	 * @param str The array of string being sorted. The str parameter contains
	 * the sorted result.
	 */
    private static void bubbleSortAscii(String[] str) {
		for (int i = 0; i < str.length-1; i++) {
			for (int j = i+1; j < str.length; j++) {
                if( str[i].compareTo(str[j]) > 0 ) {
					String t = str[i];
					str[i] = str[j];
					str[j] = t;
				}
			}
		}
	}
}
