/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "NPL"); you may not use this file except in
 * compliance with the NPL.  You may obtain a copy of the NPL at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the NPL is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the NPL
 * for the specific language governing rights and limitations under the
 * NPL.
 *
 * The Initial Developer of this code under the NPL is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1999 Netscape Communications Corporation.  All Rights
 * Reserved.
 */

import netscape.ldap.LDAPConnection;
import netscape.ldap.beans.LDAPGetEntries;
import java.awt.*;
import java.applet.Applet;
import java.beans.*;
import java.util.StringTokenizer;

/**
 * TestBeanApplet
 * 
 *
 * @version 1.0
 * @author rweltman
 **/
public class TestBeanApplet extends Applet
                            implements PropertyChangeListener {
	public void init() {
		super.init();

		setLayout(null);
		addNotify();
		int w = Integer.parseInt(getParameter("width"));
		int h = Integer.parseInt(getParameter("height"));
		resize(w+10,h+10);
		textField1 = new java.awt.TextArea(4, 60);
		textField1.setBounds(0,0,w,h);
		parseParameters();
		add(textField1);
	}

	private void parseParameters() {
		String value = getParameter( "BACKGROUND" );
		if ( (value != null) && (value.length() > 0) ) {
			System.out.println( "TestBeanApplet: BACKGROUND = " + value );
			setBackgroundColor( value );
		} else {
			System.out.println( "TestBeanApplet: BACKGROUND not found " );
		}
		value = getParameter( "FOREGROUND" );
		if ( (value != null) && (value.length() > 0) ) {
			setForegroundColor( value );
		}
		value = getParameter( "FONT" );
		if ( (value != null) && (value.length() > 0) ) {
			setTextFont( value );
		}
	}

    private Color stringToColor( String color ) {
	    if ( color.equalsIgnoreCase( "black" ) )
		    return Color.black;
	    if ( color.equalsIgnoreCase( "white" ) )
		    return Color.white;
	    if ( color.equalsIgnoreCase( "blue" ) )
		    return Color.blue;
	    if ( color.equalsIgnoreCase( "cyan" ) )
		    return Color.cyan;
	    if ( color.equalsIgnoreCase( "darkGray" ) )
		    return Color.darkGray;
	    if ( color.equalsIgnoreCase( "gray" ) )
		    return Color.gray;
	    if ( color.equalsIgnoreCase( "green" ) )
		    return Color.green;
	    if ( color.equalsIgnoreCase( "lightGray" ) )
		    return Color.lightGray;
	    if ( color.equalsIgnoreCase( "magenta" ) )
		    return Color.magenta;
	    if ( color.equalsIgnoreCase( "orange" ) )
		    return Color.orange;
	    if ( color.equalsIgnoreCase( "pink" ) )
		    return Color.pink;
	    if ( color.equalsIgnoreCase( "red" ) )
		    return Color.red;
	    if ( color.equalsIgnoreCase( "yellow" ) )
		    return Color.yellow;
		return Color.white;
	}

    public void setForegroundColor( String color ) {
	    foregroundColor = stringToColor( color );
	    textField1.setForeground( foregroundColor );
	}

    public String getForegroundColor() {
	    return foregroundColor.toString();
	}

    public void setBackgroundColor( String color ) {
	    backgroundColor = stringToColor( color );
	    textField1.setBackground( backgroundColor );
	}

    public String getBackgroundColor() {
	    return backgroundColor.toString();
	}

    private int stringToStyle( String styleString ) {
 	    int style = Font.PLAIN;
	    String s = new String( styleString );
		s.toLowerCase();
	    if ( s.indexOf( "italic" ) >= 0 )
		    style |= Font.ITALIC;
	    if ( s.indexOf( "bold" ) >= 0 )
		    style |= Font.BOLD;
 	    return style;
	}

    private Font stringToFont( String f ) {
	    // f should be in the format  name-style-points
	    StringTokenizer tok = new StringTokenizer( f, "-" );
		int nTokens = 0;
		String[] tokens = new String[3];
		while ( tok.hasMoreElements() && (nTokens < 3) ) {
		    tokens[nTokens] = tok.nextToken();
			nTokens++;
		}
		if ( nTokens == 3 ) {
			String name = tokens[0];
		    int style = stringToStyle( tokens[1] );
			int points = Integer.parseInt( tokens[2] );
			return new Font( name, style, points );
		}
		return null;
	}

    public void setTextFont( String font ) {
	    Font newFont = stringToFont( font );
        System.out.println( "TextApplet: font = " + newFont );
		if ( newFont != null ) {
		    textFont = newFont;
			textField1.setFont( textFont );
			setFont( textFont );
		}
	}

    public String getTextFont() {
	    return textFont.toString();
	}

    public void propertyChange(PropertyChangeEvent evt) {
		String newValue;
        if ( evt.getNewValue() instanceof String[] ) {
			String[] vals = (String[])evt.getNewValue();
			System.out.println( "TextApplet: received " + vals[0] );
			textField1.setText( vals[0] );
			for( int i = 1; i < vals.length; i++ ) {
				System.out.println( "TextApplet: received " + vals[i] );
				textField1.append( '\n' + vals[i] );
			}
		} else {
			textField1.setText( (String)evt.getNewValue() );
			System.out.println( "TextApplet: received " +
								(String)evt.getNewValue() );
		}
	}

	java.awt.TextArea textField1;
    private Color backgroundColor = stringToColor("white");
    private Color foregroundColor = stringToColor("black");
    private Font textFont;

    private static final String HOST = "localhost";
    private static final int PORT = 389;
    private static final String BASE = "o=airius.com";
    private static final int SCOPE = LDAPConnection.SCOPE_SUB;
    private static final String FILTER = "objectclass=groupofuniquenames";
}


