/*
		A basic implementation of the JFrame class.
*/

import javax.swing.*;
import java.awt.*;
import javax.swing.JFrame;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.ListSelectionModel;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;

import java.util.*;
import java.awt.event.*;

import javax.swing.JTextField;
import javax.swing.JList;
import javax.swing.JComboBox;
public class Charmap extends javax.swing.JFrame
{
	static boolean g_main = false;
	int g_selectedRow = 0;
	int g_selectedColumn = 0;
	String g_unicodeSubset = "latin-1";
	int g_column_latin1 = 16;
	int g_row_latin1 = 14;
	int g_base_latin1 = 0x20;

//	String g_unicodeSubset = "Hiragana";
	int g_column_hiragana = 16;
	int g_row_hiragana = 6;
	int g_base_hiragana = 0x3040;

//	String g_unicodeSubset = "Katakana";
	int g_column_katakana = 16;
	int g_row_katakana = 6;
	int g_base_katakana = 0x30A0;

//	String g_unicodeSubset = "CJK Unified";
	int g_column_cjk = 16;
	int g_row_cjk = 82; // 1312
	int g_base_cjk = 0x4E00;

	int g_base = 0x20;
	TableModel g_currentTable = null;

	Hashtable tableHash = new Hashtable();
	String[] g_sortedKey = null;

//	static String[] g_unicodeRangeNames = null;
//	static String[] g_unicodeRangeValues = null;
	
	static Hashtable unicodeRange = null;
	
static final String[] subset_name = { "Latin1",
	"Latin Extended",
	"IPA Extensions",
	"Combining Diacritical Marks",
	"Basic Greek",
	"Cyrillic",
	"Thai",
	"Georgian",
	"General Punctuation",
	"Miscellaneous Dingbats",
	"CJK Symbols and Punctuation",
	"Hangul",
	"Halfwidth and Fullwidth Forms",
	"Hebrew",
	"Hiragana and Katakana" };

static final String[] subset_start = { "\u0020",
	"\u0100",
	"\u0250",
	"\u0300",
	"\u0370",
	"\u0400",
	"\u0E00",
	"\u10A0",
	"\u2000",
	"\u2600",
	"\u3000",
	"\uAC00",
	"\uFF00",
	"\u0590",
	"\u3040" };

	
	public Charmap() {
		if (unicodeRange == null) {
			int i;		
			
			unicodeRange = new Hashtable(); 
			for (i = 0; i < subset_name.length; i++) {
				unicodeRange.put(subset_name[i], subset_start[i]);
			}	
				
			g_sortedKey = Mime.sort(unicodeRange);
		}
	
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(706,522);
		setVisible(false);

		setBackground(new Color(-3355444));		
		charmapPanel = new javax.swing.JScrollPane();		
		charmapPanel.setOpaque(true);		
		charmapPanel.setBounds(0,72,706,435);		
		charmapPanel.setFont(new Font("Dialog", Font.PLAIN, 12));		
		charmapPanel.setForeground(new Color(0));		
		charmapPanel.setBackground(new Color(16777215));		
		getContentPane().add("Center", charmapPanel);		
		charmapTable = new javax.swing.JTable();		
		charmapTable.setRowHeight(18);		
		charmapTable.setBounds(0,0,520,377);		
		charmapTable.setFont(new Font("Serif", Font.PLAIN, 16));		
		charmapTable.setForeground(new Color(0));		
		charmapTable.setBackground(new Color(16777215));		
		charmapPanel.getViewport().add(charmapTable);		
		controlPanel = new javax.swing.JPanel();		
		controlPanel.setLayout(new BorderLayout(0,0));		
		controlPanel.setBounds(0,0,706,72);		
		controlPanel.setFont(new Font("Dialog", Font.PLAIN, 12));		
		controlPanel.setForeground(new Color(0));		
		controlPanel.setBackground(new Color(-3355444));		
		getContentPane().add("North", controlPanel);		
		cmdPanel = new javax.swing.JPanel();		
		cmdPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));		
		cmdPanel.setBounds(0,0,706,37);		
		cmdPanel.setFont(new Font("Dialog", Font.PLAIN, 12));		
		cmdPanel.setForeground(new Color(0));		
		cmdPanel.setBackground(new Color(-3355444));		
		controlPanel.add("North", cmdPanel);		
		nextButton = new javax.swing.JButton();		
		nextButton.setText("Next");		
		nextButton.setActionCommand("Next");		
		nextButton.setBounds(164,6,61,25);		
		nextButton.setFont(new Font("Dialog", Font.BOLD, 12));		
		nextButton.setForeground(new Color(0));		
		nextButton.setBackground(new Color(-3355444));		
		cmdPanel.add(nextButton);		
		latin1Button = new javax.swing.JButton();		
		latin1Button.setText("Latin-1");		
		latin1Button.setActionCommand("Latin-1");		
		latin1Button.setBounds(230,6,73,25);		
		latin1Button.setFont(new Font("Dialog", Font.BOLD, 12));		
		latin1Button.setForeground(new Color(0));		
		latin1Button.setBackground(new Color(-3355444));		
		cmdPanel.add(latin1Button);		
		cjkButton = new javax.swing.JButton();		
		cjkButton.setText("CJK Unified");		
		cjkButton.setActionCommand("CJK Unified");		
		cjkButton.setBounds(308,6,99,25);		
		cjkButton.setFont(new Font("Dialog", Font.BOLD, 12));		
		cjkButton.setForeground(new Color(0));		
		cjkButton.setBackground(new Color(-3355444));		
		cmdPanel.add(cjkButton);		
		rangeComboBox = new javax.swing.JComboBox();		
		rangeComboBox.setBounds(412,5,130,27);		
		rangeComboBox.setFont(new Font("Dialog", Font.BOLD, 12));		
		rangeComboBox.setForeground(new Color(0));		
		rangeComboBox.setBackground(new Color(-3355444));		
		cmdPanel.add(rangeComboBox);		
		inputPanel = new javax.swing.JPanel();		
		inputPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));		
		inputPanel.setBounds(0,37,706,35);		
		inputPanel.setFont(new Font("Dialog", Font.PLAIN, 12));		
		inputPanel.setForeground(new Color(0));		
		inputPanel.setBackground(new Color(-3355444));		
		controlPanel.add("South", inputPanel);		
		jLabel1 = new javax.swing.JLabel();		
		jLabel1.setText("Clicked Text:");		
		jLabel1.setBounds(255,10,73,15);		
		jLabel1.setFont(new Font("Dialog", Font.BOLD, 12));		
		jLabel1.setForeground(new Color(-10066279));		
		jLabel1.setBackground(new Color(-3355444));		
		inputPanel.add(jLabel1);		
		echoTextField = new javax.swing.JTextField();		
		echoTextField.setMargin(new java.awt.Insets(0,0,0,0));		
		echoTextField.setBounds(333,5,4,24);		
		echoTextField.setFont(new Font("Serif", Font.PLAIN, 16));		
		echoTextField.setForeground(new Color(0));		
		echoTextField.setBackground(new Color(16777215));		
		inputPanel.add(echoTextField);		
		clearButton = new javax.swing.JButton();		
		clearButton.setText("Clear");		
		clearButton.setActionCommand("Clear");		
		clearButton.setBounds(342,5,65,25);		
		clearButton.setFont(new Font("Dialog", Font.BOLD, 12));		
		clearButton.setForeground(new Color(0));		
		clearButton.setBackground(new Color(-3355444));		
		inputPanel.add(clearButton);		
		jLabel2 = new javax.swing.JLabel();		
		jLabel2.setText("Goto:");		
		jLabel2.setBounds(412,10,29,15);		
		jLabel2.setFont(new Font("Dialog", Font.BOLD, 12));		
		jLabel2.setForeground(new Color(-10066279));		
		jLabel2.setBackground(new Color(-3355444));		
		inputPanel.add(jLabel2);		
		gotoTextField = new javax.swing.JTextField();		
		gotoTextField.setMargin(new java.awt.Insets(0,0,0,0));		
		gotoTextField.setBounds(446,8,4,19);		
		gotoTextField.setFont(new Font("SansSerif", Font.PLAIN, 12));		
		gotoTextField.setForeground(new Color(0));		
		gotoTextField.setBackground(new Color(16777215));		
		inputPanel.add(gotoTextField);		
		statusPanel = new javax.swing.JPanel();		
		statusPanel.setLayout(new BorderLayout(0,0));		
		statusPanel.setBounds(0,507,706,15);		
		statusPanel.setFont(new Font("Dialog", Font.PLAIN, 12));		
		statusPanel.setForeground(new Color(0));		
		statusPanel.setBackground(new Color(-3355444));		
		getContentPane().add("South", statusPanel);		
		charStatus = new javax.swing.JLabel();		
		charStatus.setText("Selected Char:");		
		charStatus.setBounds(0,0,706,15);		
		charStatus.setFont(new Font("Dialog", Font.BOLD, 12));		
		charStatus.setForeground(new Color(-10066279));		
		charStatus.setBackground(new Color(-3355444));		
		statusPanel.add("Center", charStatus);
		
		echoTextField.setPreferredSize(new Dimension(200, 24));
		gotoTextField.setPreferredSize(new Dimension(45, 24));

		if (g_sortedKey != null) {
     		for (int i = 0; i < g_sortedKey.length; i ++) {
         		rangeComboBox.addItem(g_sortedKey[i]); 
     		}
		}

		rangeComboBox.addActionListener (new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String key = (String) rangeComboBox.getSelectedItem();
				String value = (String) unicodeRange.get(key);

				g_currentTable = getTableModel(value.charAt(0));
				if (g_currentTable != null)
       				charmapTable.setModel(g_currentTable);
				setCharInfoOnStatus(true);	
				repaint();
			}
		});
		

		cjkButton.addActionListener (new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				TableModel table;				

				table = getTableModel("CJK Unified");
				if (table != null) {
					g_currentTable = table;
       				charmapTable.setModel(g_currentTable);
					setCharInfoOnStatus(true);	
					repaint();
				}
			}
		});

		latin1Button.addActionListener (new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				TableModel table;				

				table = getTableModel("latin-1");
				if (table != null) {
					g_currentTable = table;
       				charmapTable.setModel(g_currentTable);
					setCharInfoOnStatus(true);	
					repaint();
				}
			}
		});

		nextButton.addActionListener (new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				TableModel table;				

				table = getTableModel("Next");
				if (table != null) {
					g_currentTable = table;
       				charmapTable.setModel(g_currentTable);
					setCharInfoOnStatus(true);	
					repaint();
       			}
			}
		});

		g_currentTable = getTableModel(g_unicodeSubset);

		if (g_currentTable != null)
       		charmapTable.setModel(g_currentTable);

		charmapTable.setCellSelectionEnabled(true);
		charmapTable.setRowSelectionAllowed(false);
	
		ListSelectionModel lsm = charmapTable.getSelectionModel();
		lsm.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {
					boolean changed = false;
					int new_row, new_col;

					new_row = charmapTable.getSelectedRow();
					new_col = charmapTable.getSelectedColumn();

					if ((new_row >= 0) && (g_selectedRow != new_row)) {
						changed = true;
						g_selectedRow = new_row;
					}
					if ((new_col >= 0) && (g_selectedColumn != new_col)) {
						changed = true;
						g_selectedColumn = new_col;
					}
					
					if (changed == true) {
						System.out.println("JTable  " + charmapTable.getSelectedColumn() +
							":" + charmapTable.getSelectedRow());
						setCharInfoOnStatus(false);	
					}
				}
			}		
		});
		
		clearButton.addActionListener (new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				echoTextField.setText("");
			}
		});

		gotoTextField.addActionListener (new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				TableModel table;				
				char startChar ;
				String text;

				text = gotoTextField.getText();
				if (text.length() <= 0)
					return;

				if (text.startsWith("\\u") == true && text.length() >= 6) {
					byte bs[];
					String s;

					s = Mime.escapedUnicodeToText((text.substring(0,6)).getBytes());					
					startChar = s.charAt(0);
				}
				else
					startChar = text.charAt(0);

				table = getTableModel(startChar);
				if (table != null) {
					g_currentTable = table;
       				charmapTable.setModel(g_currentTable);
					setCharInfoOnStatus(true);	
					repaint();
       			}

				System.out.println("goto action");
			}
		});



		TableModel tm = charmapTable.getModel();
		tm.addTableModelListener(new TableModelListener() {
				public void tableChanged(TableModelEvent e) {
					System.out.println("table: value chagned!!!");
				};
			});
		
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}
	}

	public Charmap(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	javax.swing.JScrollPane charmapPanel;	
	javax.swing.JTable charmapTable;	
	javax.swing.JPanel controlPanel;	
	javax.swing.JPanel cmdPanel;	
	javax.swing.JButton nextButton;	
	javax.swing.JButton latin1Button;	
	javax.swing.JButton cjkButton;	
	javax.swing.JComboBox rangeComboBox;	
	javax.swing.JPanel inputPanel;	
	javax.swing.JLabel jLabel1;	
	javax.swing.JTextField echoTextField;	
	javax.swing.JButton clearButton;	
	javax.swing.JLabel jLabel2;	
	javax.swing.JTextField gotoTextField;	
	javax.swing.JPanel statusPanel;	
	javax.swing.JLabel charStatus;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Charmap.this)
				JFrame1_WindowClosing(event);
		}
	}

	void JFrame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		if (g_main == true)
			System.exit(0);    // close the application
	}

	void setCharInfoOnStatus(boolean baseOnly) {
		if (baseOnly == false) {
			Character value = (Character) (g_currentTable.getValueAt(g_selectedRow, g_selectedColumn));
			String sValue = Mime.toHexString(value.charValue());
			String utf8;
			String utf7;

			try {
				utf8 = new String((value.toString()).getBytes("UTF8"), "8859_1");
				utf8 = Mime.toHexString(utf8);
				utf7 = Mime.encodeModifiedBase64(value.charValue());
			}
			catch (Exception e) {
				utf8 = " ";
				utf7 = " ";
			}

			charStatus.setText("selected char:" + 
				"  value = " + sValue + 
				"  UTF-8 = " + utf8 +
				"  UTF-7 = " + "+" + utf7);
			echoTextField.setText(echoTextField.getText() + value.toString());
		}
		else {
			charStatus.setText("Base = " + Mime.toHexString((char) g_base));
		}
	}

	TableModel getTableModel(String subset) {
		TableModel dataModel;
		if (subset.compareTo("latin-1") == 0) {
			g_base = g_base_latin1;
			dataModel = (TableModel) tableHash.get("latin-1");
			if (dataModel != null)
				return dataModel;

       		dataModel = new AbstractTableModel() {
       			public int getColumnCount() { return g_column_latin1; }
           		public int getRowCount() { return g_row_latin1;}
           		public Object getValueAt(int row, int col) { 
					return new Character ((char) (g_base_latin1 + row*g_column_latin1 + col)); 
				}
	   		};
			tableHash.put("latin-1", dataModel);

			return dataModel;
		}
		else if (subset.compareTo("Hiragana") == 0) {
			g_base = g_base_hiragana;
			dataModel = (TableModel) tableHash.get("Hiragana");
			if (dataModel != null)
				return dataModel;

       		dataModel = new AbstractTableModel() {
       			public int getColumnCount() { return g_column_hiragana; }
           		public int getRowCount() { return g_row_hiragana;}
           		public Object getValueAt(int row, int col) { 
					return new Character ((char) (g_base_hiragana + row*g_column_hiragana + col)); 
				}
	   		};
			tableHash.put("Hiragana", dataModel);

			return dataModel;
		}
		else if (subset.compareTo("Katakana") == 0) {
			g_base = g_base_katakana;
			dataModel = (TableModel) tableHash.get("Katakana");
			if (dataModel != null)
				return dataModel;

       		dataModel = new AbstractTableModel() {
       			public int getColumnCount() { return g_column_katakana; }
           		public int getRowCount() { return g_row_katakana;}
           		public Object getValueAt(int row, int col) { 
					return new Character ((char) (g_base_katakana + row*g_column_katakana + col)); 
				}
	   		};
			tableHash.put("Katakana", dataModel);

			return dataModel;
		}
		else if (subset.compareTo("CJK Unified") == 0) {
			g_base = g_base_cjk;
			dataModel = (TableModel) tableHash.get("CJK Unified");
			if (dataModel != null)
				return dataModel;

       		dataModel = new AbstractTableModel() {
       			public int getColumnCount() { return g_column_cjk; }
           		public int getRowCount() { return g_row_cjk;}
           		public Object getValueAt(int row, int col) { 
					return new Character ((char) (g_base_cjk + row*g_column_cjk + col)); 
				}
	   		};
			tableHash.put("CJK Unified", dataModel);

			return dataModel;
		}
		else if (subset.compareTo("Next") == 0) {
			int base;
			base = g_base + g_currentTable.getColumnCount()*g_currentTable.getRowCount();
			if (base >= 0xFFFF)
				return null;

			g_base = base;

       		dataModel = new AbstractTableModel() {	
       			public int getColumnCount() { return 16; }; 
           		public int getRowCount() { return 16;}
           		public Object getValueAt(int row, int col) { 
					if ((g_base + row*16 + col) <= 0xFFFF)
						return new Character ((char) (g_base + row*16 + col)); 
					else
						return new Character (' ');
				}
	   		};

			return dataModel;
		}

		return null;
	}	

	TableModel getTableModel(char startChar) {
		TableModel dataModel;

		startChar = (char) (startChar & 0xFFF0);

		g_base = startChar;

   		dataModel = new AbstractTableModel() {	
   			public int getColumnCount() { return 16; }; 
       		public int getRowCount() { return 16;}
       		public Object getValueAt(int row, int col) { 
				if ((g_base + row*16 + col) <= 0xFFFF)
					return new Character ((char) (g_base + row*16 + col)); 
				else
					return new Character (' ');
			}
	   	};

		return dataModel;	
	}

	static public void main(String args[])
	{
	   	try {	      
			// 	UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());	   
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());	   
		} 
		catch (Exception exc) {	      
			System.err.println("Error loading L&F: " + exc);	   
		}

		g_main = true;
		(new Charmap("Charmap")).setVisible(true);
	}
}
