/* Copyright Notice ======================================================*
* This file contains proprietary information of Netscape Communications.
* Copying or reproduction without prior written approval is prohibited.
* Copyright (c) 1997 ====================================================*/

package util;

import java.awt.Toolkit;
import java.util.Hashtable;
import java.io.InputStream;
import java.io.IOException;
import javax.swing.ImageIcon;

public class ImageUtil {

	static String getImageDir() {
		return _sImageDir;
	}

    public static ImageIcon getPackageImage( String name ) {
		ImageIcon i = (ImageIcon)_cPackageImages.get( name );
		if ( i != null )
			return i;
        i = getSystemImage( getImageDir() + "/" + name );
		if ( i != null ) {
			_cPackageImages.put( name, i );
			Debug.println( "ImageUtil.getPackageImage: found " + name );
		} else {
			Debug.println( "ImageUtil.getPackageImage: not found " +
						   getImageDir() + "/" + name );
		}
		return i;
	}

    static class StackLookup extends SecurityManager {
        public ClassLoader getLoader() {
            Class[] stack = getClassContext();

            // magic number 3 is the class which called RemoteImage, and
            // we want its loader.
            Class c = stack[3];
            return ((c == null) ? null : c.getClassLoader());
        }
    }

	/**
	 * Get image remotely or from CLASSPATH.
	 */
    static ImageIcon getSystemImage( String path ) {
		InputStream is = RemoteLoadUtil.getRemoteObject( path );
		if ( is != null ) {
			try {
				byte[] buf = new byte[is.available()];
				is.read(buf);
				return new ImageIcon(
					Toolkit.getDefaultToolkit().createImage(buf));
			} catch (Exception e) {
				Debug.println(0, "ImageUtil.getSystemImage: " + e +
							  "(" + path + ")");
				return null;
			}
        } else {
            return null;
        }
    }

	private static final String  _sImageDir	=
    	"images"; // Icons live here
    // Keep track of loaded images, so they only need to be loaded once
	private static Hashtable _cPackageImages = new Hashtable();
}
