/* Copyright Notice ======================================================*
* This file contains proprietary information of Netscape Communications.
* Copying or reproduction without prior written approval is prohibited.
* Copyright (c) 1997 ====================================================*/

package util;

import java.awt.Toolkit;
import java.io.InputStream;
import java.io.IOException;

public class RemoteLoadUtil {

    static class StackLookup extends SecurityManager {
        public ClassLoader getLoader() {
            Class[] stack = getClassContext();

            // magic number 3 is the class which called ResourceSet, and
            // we want its loader.
            Class c = stack[3];
            return ((c == null) ? null : c.getClassLoader());
        }
    }

	/**
	 * Get object remotely or from CLASSPATH.
	 */
    static InputStream getRemoteObject( String path ) {
        InputStream is;

        try {
            ClassLoader cl = new StackLookup().getLoader();

            if (cl != null) {
                if ((is = cl.getResourceAsStream(path)) == null)
                    return null;
            } else {
                if ((is = ClassLoader.getSystemResourceAsStream(path)) ==
                        null)
                    return null;
            }
			return is;
        } catch (Exception e) {
            Debug.println(0, "RemoteLoadUtil.getRemoteObject: " + e +
						  "(" + path + ")");
            return null;
        }
    }
}
