/* ======================================================================
 * Copyright (c) 1997 Netscape Communications Corporation
 * This file contains proprietary information of Netscape Communications.
 * Copying or reproduction without prior written approval is prohibited.
 * ======================================================================
 */

package util;

import java.io.Serializable;

/**
 * SimpleReferral
 * For having an LDAPConnection follow referrals by just reusing the
 * same authentication DN and password.
 *
 * @version 1.0
 * @author rweltman
 **/
public class SimpleReferral implements netscape.ldap.LDAPRebind,
                            Serializable {
	/**
	 * Just save the credentials on construction
	 *
	 * @param dn The authentication DN to use
	 * @param password The authentication password to use
	 */
    public SimpleReferral( String dn, String password ) {
		_dn = dn;
		_password = password;
	}

	/**
	 * Always returns the same credentials for referrals
	 *
	 * @param host The referred-to host (ignored)
	 * @param port The referred-to port (ignored)
	 * @return Credentials for referral-following
	 */
    public netscape.ldap.LDAPRebindAuth getRebindAuthentication( String host,
																 int port ) {
		return new netscape.ldap.LDAPRebindAuth( _dn, _password );
	}
	private String _dn;
	private String _password;
}
